/*
   This program parses and then evaluates strings from Language-12.
*/

public class Examples
{
   public static void main(String[] args)
   {
      // Show that function return values are allowed.
      String expr1 = "( prog " +
                       "( define add " +
                           "( lambda  x " +
                                "( begin " +
                                  "( var r ( lambda y ( + x y ) ) ) " +  // r is a nested function
                                  "r ) ) ) " +                           // return the nested function
                       "( begin " +
                          "( var add2 ( apply add 2 ) ) " + // add returns a function
                          "( apply add2 3 ) ) )";           // call the returned function


      String expr2 = "( prog " +
                       "( define makeCounter " +
                           "( lambda x " +
                                "( begin " +
                                  "( var r ( lambda ( + x 1 ) ) ) " +
                                  "r ) ) ) " +
                       "( begin " +
                          "( var c1 ( apply makeCounter 1 ) ) " +
                          "( var c2 ( apply makeCounter 3 ) ) " +
                          "( print ( var n1 ( apply c1 ) ) ) " +
                          "( print ( set n1 ( apply c1 ) ) ) " +
                          "( print ( set n1 ( apply c1 ) ) ) " +
                          "( print ( var n2 ( apply c2 ) ) ) " +
                          "( print ( set n2 ( apply c2 ) ) ) " +
                          "( print ( set n2 ( apply c2 ) ) ) " +
                          "( print ( set n1 ( apply c1 ) ) ) ) )";


      String expr3 = "( prog " +
                       "( define incrementBy " +
                           "( lambda x " +
                                "( begin " +
                                  "( var r ( lambda y ( +  y x ) ) ) " +
                                  "r ) ) ) " +
                       "( begin " +
                          "( var incrementBy2 ( apply incrementBy 2 ) ) " +
                          "( var incrementBy3 ( apply incrementBy 3 ) ) " +
                          "( print ( var n1 ( apply incrementBy2 10 ) ) ) " +
                          "( print ( set n1 ( apply incrementBy2 n1 ) ) ) " +
                          "( print ( set n1 ( apply incrementBy3 n1 ) ) ) " +
                          "( print ( set n1 ( apply incrementBy3 n1 ) ) ) " +
                          "( print ( set n1 ( apply incrementBy2 n1 ) ) ) ) )";


      // This should work, but it doesn't. What does our language still need?
      String expr4 = "( prog " +
                       "( define add " +
                           "( lambda  x " +
                                "( begin " +
                                  "( var r ( lambda y ( + x y ) ) ) " +
                                  "r ) ) ) " +
                       "( apply ( apply add 2 ) 3 ) )"; // add returns a function


      String expr = expr1;

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Examples